#import "SSL.h"
#import <WebObjects/WOApplication.h>
#import <Foundation/Foundation.h>

@interface WOContext (PrivateHeaders)
- (void)_generateCompleteURLs;
@end

@implementation SSL

+ (void)enableSSLInContext:(WOContext *)context {
        NSMutableString *url;
        NSRange range;

        if ([WOApplication isDirectConnectEnabled] == NO) {
                url = [[WOApplication cgiAdaptorURL] mutableCopy];
                range = [url rangeOfString:HTTP_STRING];

                if (range.length > 0) {
			[url replaceCharactersInRange:range withString:HTTPS_STRING];
			[WOApplication setCGIAdaptorURL:url];
                }
                [context _generateCompleteURLs];
        }
}

+ (void)disableSSLInContext:(WOContext *)context {
        NSMutableString *url;
        NSRange range;

        if ([WOApplication isDirectConnectEnabled] == NO) {
                url = [[WOApplication cgiAdaptorURL] mutableCopy];
                range = [url rangeOfString:HTTPS_STRING];

                if (range.length > 0) {
			[url replaceCharactersInRange:range withString:HTTP_STRING];
			[WOApplication setCGIAdaptorURL:url];
		}
		[context _generateCompleteURLs];
        }
}

@end
