#import "SSLContainer.h"
#import "SSL.h"

@class WOHTMLStaticGroup; // it's private

@implementation SSLContainer

- (id)initWithName:(NSString*)aName associations:(NSDictionary*)someAssociations template:(WOElement*)aTemplate {
	return [self initWithName:aName associations:someAssociations contentElements:[NSArray arrayWithObject:aTemplate]];
}

- (id)initWithName:(NSString*)aName associations:(NSDictionary*)someAssociations contentElements:(NSArray*)contents {
  NS_DURING
	self = [super initWithName:aName associations:nil template:nil];
        if (!self) {
            [NSException raise:NSGenericException format:@"Superclass initialization."];
        }

  NS_HANDLER
        [self release];
        self = nil;
	[NSException raise:[localException name] format:@"SSLContainer: %@", [localException description]];

  NS_ENDHANDLER
#warning Ignore these 2 "cannot find method" warnings...
	childrenGroup = [[WOHTMLStaticGroup alloc] initWithContentElements: contents];
	return self;
}	

- (void)dealloc {
        [childrenGroup release];
        [super dealloc];
}

- (void)takeValuesFromRequest:(WORequest*)aRequest inContext:(WOContext*)aContext {
	[SSL enableSSLInContext:aContext];
        [childrenGroup takeValuesFromRequest:aRequest inContext:aContext];
	[SSL disableSSLInContext:aContext];
}

- (WOElement*)invokeActionForRequest:(WORequest*)aRequest inContext:(WOContext*)
aContext {
	WOElement *element;
	
	[SSL enableSSLInContext:aContext];
	element = [childrenGroup invokeActionForRequest:aRequest inContext:aContext];
	[SSL disableSSLInContext:aContext];

	return element;
}

- (void)appendToResponse:(WOResponse*)aResponse inContext:(WOContext*)aContext {
	[SSL enableSSLInContext:aContext];
	[childrenGroup appendToResponse:aResponse inContext:aContext];
	[SSL disableSSLInContext:aContext];
}

@end
